// ignore_for_file: unnecessary_const, prefer_const_constructors, unused_local_variable

library main;

import 'package:url_launcher/url_launcher.dart';

import 'package:flutter/material.dart';
import 'package:xtoolspackage/xtoolspackage.dart';
import 'package:xwidgetsbase/XStylesBase.dart';
import 'package:xwidgetsbase/xWidgetsBase.dart';

class XAppBase extends StatelessWidget {
  Map<String, Widget Function(BuildContext)> routes = const <String, WidgetBuilder>{};
  dynamic appState;
  String? initialPage = "";
  XAppBase(
    this.routes, {
    this.appState,
    this.initialPage,
  });

  /// url! + "?contanierName=$blobContainer&id=$itemID"  Utilizzato per aprire i documenti
  static launchURLBrowser(String? blobContainer, String? itemID, String? url) async {
    var fullURL = url! + "?contanierName=$blobContainer&id=$itemID";
    if (await canLaunch(url)) {
      await launch(url);
    } else {
      throw 'Could not launch $url';
    }
  }

  /// utilizzalo per avere una lista di documenti
  static List<Widget> xuiGetDocsGallery({required BuildContext context, required List<dynamic> docsFileList, required void Function(dynamic) onDelete, Function(dynamic i)? onPressedEdit, String? urlToOpenFile}) {
    var retval = <Widget>[];
    if (docsFileList.isNotEmpty) {
      for (var i in docsFileList) {
        retval.add(GestureDetector(
            onTap: () => launchURLBrowser(i.blobContainer, i.id, urlToOpenFile),
            child: Card(
                color: Colors.grey[850],
                child: Row(children: [
                  Expanded(flex: 2, child: Container(padding: EdgeInsets.only(top: 5, left: 5, bottom: 5), child: Text(i.fileName!))),
                  SizedBox(width: 10),
                  Container(padding: EdgeInsets.only(top: 5, left: 5, bottom: 5), width: 80, child: Text(XUtils.dateToString(i.dtFile!))),
                ]))));
      }
    } else {
      retval.add(Container());
    }
    return retval;
  }

  /// utilizzalo per avere una lista di immagini
  static List<Widget> xuiGetGalleria({required BuildContext context, required List<dynamic> imagesFileList, dynamic Function()? onTapImage, required void Function(dynamic) onDelete, required Function(dynamic i) onPressedEdit}) {
    var retval = <Widget>[];
    if (imagesFileList.isNotEmpty) {
      for (var i in imagesFileList) {
        retval.add(XContainerForImage(
            widthContainer: 120,
            heightContainer: 140,
            visibleRow: true,
            image: i.imageContent!,
            onTapImage: onTapImage,
            onPressedDelete: () {
              return showDialog(
                  context: context,
                  builder: (BuildContext context) {
                    return AlertDialog(
                        title: const Center(
                            child: const Text(
                          'Sei sicuro di voler cancellare la foto? Una volta cancellata non sarà più recuperabile!!!',
                          style: const TextStyle(fontSize: 18, color: Colors.white),
                        )),
                        content: Column(mainAxisSize: MainAxisSize.min, children: <Widget>[
                          Row(mainAxisAlignment: MainAxisAlignment.spaceBetween, children: <Widget>[
                            Expanded(
                                child: TextButton(
                                    child: const Text('Si', style: TextStyle(fontSize: 18, color: Colors.greenAccent)),
                                    onPressed: () {
                                      Navigator.pop(context, true);
                                      onDelete(i);
                                    })),
                            Expanded(
                                child: TextButton(
                                    child: const Text('No', style: TextStyle(fontSize: 18, color: Colors.redAccent)),
                                    onPressed: () {
                                      Navigator.pop(context, null);
                                    })),
                          ])
                        ]));
                  });
            },
            onPressedEdit: () {
              onPressedEdit(i);
            }));
      }
    } else {
      retval.add(Container());
    }
    return retval;
  }

  ///Alert per il trona insietro senza aver salvato
  static alertDialogForPop(BuildContext context, Function()? onPressedYes) {
    return showDialog(
        context: context,
        builder: (context) {
          return XAlertDialog(
            heightAlertDialog: 35,
            styleTitle: XStyles.xStyTextForSubLabel(),
            titleText: "Vuoi annullare le modifiche fatte?",
            labelBTNyes: "SI",
            labelBTNno: "NO",
            colorYes: Colors.greenAccent,
            colorNo: Colors.redAccent,
            onPressedYes: () {
              Navigator.pop(context);
              onPressedYes?.call();
            },
            onPressedNo: () {
              Navigator.pop(context);
            },
          );
        });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      routes: routes,
      title: "",
      initialRoute: initialPage,
      debugShowCheckedModeBanner: false,
      theme: ThemeData(
        primarySwatch: Colors.blue,
        brightness: Brightness.dark,
        primaryColor: Colors.lightBlue[800],
        textTheme: const TextTheme(
          headline1: TextStyle(fontSize: 72.0, fontWeight: FontWeight.bold),
          headline6: TextStyle(fontSize: 36.0, fontStyle: FontStyle.normal),
          bodyText2: TextStyle(fontSize: 14.0, fontFamily: 'Hind'),
          bodyText1: TextStyle(fontSize: 16, fontWeight: FontWeight.bold),
          caption: TextStyle(
            fontSize: 12,
          ),
        ),
      ),
    );
  }
}
