library xfxevolvedwidget;

import 'package:flutter/material.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:xtoolspackage/xtoolspackage.dart';
import 'package:xwidgetsbase/XStylesBase.dart';
import 'package:xwidgetsbase/xWidgetsBase.dart';

class XHomePage extends StatefulWidget {
  XHomePage(
    this.listBTNmenu, {
    this.refreshDataFromServer,
    Key? key,
    this.title = "Home",
    this.backGroundColorAppBar = Colors.blue,
    this.appVersion,
    this.labelBTNsync,
    this.colorBTNsync,
    this.borderRadiusBTNsync,
    this.syncBTNvisible = false,
  }) : super(key: key);
  final String? title;
  final List<XBtnbase>? listBTNmenu;
  final Future<dynamic>? refreshDataFromServer;
  final Color? backGroundColorAppBar;
  final String? appVersion;
  final String? labelBTNsync;
  final Color? colorBTNsync;
  final double? borderRadiusBTNsync;
  final bool syncBTNvisible;
  @override
  _XHomePageState createState() => _XHomePageState();
}

class _XHomePageState extends State<XHomePage> {
  static bool isBusy = false;
  static String messageForUser = "";

/////////// B L //////////
  cmdGoTo(String pageName) {
    Navigator.of(context).pushNamed(pageName);
  }

  cmdLogOut() {
    SharedPreferences.getInstance().then((prefs) {
      prefs.clear();
    });
    Navigator.pop(context);
  }

  Future refreshDataFromServer() async {
    setState(() {
      isBusy = true;
      messageForUser = "Aggiornamento dati dal server in corso...";
    });

    await widget.refreshDataFromServer!
        .then((value) => {
              setState(() {
                isBusy = false;
                messageForUser = "Aggiornamento dati terminato, App pronta all'uso.";
              })
            })
        .catchError((err) {
      messageForUser = "Impossibile contattare il server, riprovare quando si è connessi in WiFi";
    });
  }

/////////// C O M P O N E N T S ///////////

  menuform() {
    return Column(children: <Widget>[
      isBusy
          ? Container()
          : Wrap(
              spacing: 20, //SPAZIO IN VERTICALE
              runSpacing: 10, //SPAZIO IN ORIZZONTALE
              direction: Axis.vertical,
              children: widget.listBTNmenu!
                  .map((item) => GestureDetector(
                      onTap: () {},
                      child: XBtnbase(
                        widthBTN: item.widthBTN,
                        heightBTN: item.heightBTN,
                        decorationBTN: item.decorationBTN,
                        label: item.label,
                        elevation: item.elevation,
                        icon: item.icon,
                        iconColor: item.iconColor,
                        styleLabel: item.styleLabel,
                        nameOfPageToGo: item.nameOfPageToGo,
                        buildContextOfPage: context,
                      )))
                  .toList(),
            ),
      SizedBox(height: 20),
      widget.syncBTNvisible
          ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
              Container(
                  width: 300,
                  child: XBtnbase(
                      decorationBTN: BoxDecoration(color: isBusy.not() ? widget.colorBTNsync ?? Color(0xFFB2F14242) : Colors.grey, borderRadius: BorderRadius.all(Radius.circular(widget.borderRadiusBTNsync ?? 10))),
                      label: widget.labelBTNsync ?? "Sincronizza con Ufficio",
                      elevation: 10,
                      icon: XIcons.xicon_Refresh,
                      iconColor: XColors.xcolor_ForegroundLight,
                      styleLabel: XStyles.xStyTextForTextBase(),
                      onPressed: isBusy
                          ? null
                          : () {
                              if (isBusy.not()) {
                                refreshDataFromServer();
                              } else {}
                            }))
            ])
          : Container(),
      SizedBox(height: 10)
    ]);
  }

  @override
  void dispose() {
    super.dispose();
  }

  Future<bool> warnLogOff(BuildContext context) async {
    var rval = await showDialog<bool>(
      context: context,
      builder: (c) => AlertDialog(
        title: const Text(
          'Attenzione',
          textAlign: TextAlign.center,
        ),
        content: const Text('Sei sicuro di disconnetterti?'),
        actions: [
          TextButton(
            style: TextButton.styleFrom(
              primary: Colors.green,
            ),
            onPressed: () => Navigator.pop(c, true),
            child: const Text('Si'),
          ),
          TextButton(
            style: TextButton.styleFrom(
              primary: Colors.red,
            ),
            onPressed: () => Navigator.pop(c, false),
            child: const Text('No'),
          )
        ],
      ),
    );
    return rval ?? false;
  }

  @override
  Widget build(BuildContext context) {
    return WillPopScope(
        onWillPop: () => warnLogOff(context),
        child: GestureDetector(
            onTap: () {},
            child: Scaffold(
              backgroundColor: XColors.xcolor_BackgroundDark,
              appBar: AppBar(
                title: Text(widget.title ?? "", style: TextStyle(color: XColors.xcolor_ForegroundLight, fontSize: 20)),
                centerTitle: true,
                backgroundColor: widget.backGroundColorAppBar,
                actions: [Container(alignment: Alignment.center, width: 80, child: Text(widget.appVersion ?? "1.0", style: XStyles.xStyTextForDescr()))],
              ),
              body: Stack(
                children: [
                  Column(
                    children: [
                      Expanded(
                          child: SingleChildScrollView(
                              child: Container(
                                  margin: const EdgeInsets.only(bottom: 10),
                                  child: Column(
                                    mainAxisAlignment: MainAxisAlignment.end,
                                    children: [
                                      Container(margin: const EdgeInsets.only(bottom: 250, top: 80), child: Row(mainAxisAlignment: MainAxisAlignment.center, children: [menuform()])),
                                    ],
                                  )))),
                      Row(children: [Expanded(child: Container(margin: const EdgeInsets.all(5), padding: const EdgeInsets.all(5), color: Colors.grey[850], child: Text(messageForUser, textAlign: TextAlign.center)))]),
                    ],
                  ),
                  // XStatefulWidgetBase.LoaderIndicator(isBusy),
                ],
              ),
            )));
  }
}
