import 'package:flutter/material.dart';
import 'package:xwidgetsbase/xWidgetsBase.dart';

/// Displays detailed information about a SampleItem.
class XfxScheda extends StatelessWidget {
  final List<Widget>? tabs;
  final TabController? tabController;
  final List<Widget>? childrenOfTabViewer;
  final List<BottomNavigationBarItem>? childrenOfBottomBar;
  const XfxScheda({Key? key, this.tabs, this.tabController, this.childrenOfTabViewer, this.childrenOfBottomBar}) : super(key: key);

  static const String routeName = '/sample_item';

  @override
  Widget build(BuildContext context) {
    return XfxSchedaTabbed(
      numberOfTabs: tabs!.length,
      childrenOfBottomBar: childrenOfBottomBar ?? [],
      bottomNavigationBarvisible: childrenOfBottomBar!.isNotEmpty ? true : false,
      tabController: tabController,
      tabs: tabs ?? [],
      childrenOfTabViewer: childrenOfTabViewer ?? [],
    );
  }
}
